<template>
  <transition name="modal">
    <div class="modal__wrapper" @click="$emit('close')">
      <transition name="v-transition-modal">
        <div v-if="transition" class="modal-content" :class="{[`${backgroundColor}`]:backgroundColor}" @click.stop="" :style="{padding: noBorder && '0px'}">
          <!-- header -->
          <div class="modal-header" v-if="title">
            <span class="modal-title"> {{ title }} </span>
          </div>
          <span class="button-close" title="close" v-if="isClose" @click="$emit('close')"></span>
          <!-- body -->
          <div class="modal-body" :style="{padding: noBorder && '0px'}">
            <slot name="body">Default body</slot>
          </div>
          <div v-if="isConfirm" class="col-2" style="float: right">
            <label class="button primary block" for="modal-ok">
              Ok
            </label>
            <input
              @click="$emit('close')"
              style="visibility: hidden; position: absolute"
              type="submit"
              id="modal-ok"
            />
          </div>
        </div>
      </transition>
    </div>
  </transition>
</template>

<script>
export default {
  props: {
    title: {
      type: String,
      required: false
    },
    isClose: {
      type: Boolean,
      default: false,
      required: false
    },
    isConfirm: {
      type: Boolean,
      default: false,
      required: false
    },
    noBorder: {
      type: Boolean,
      default: false,
      required: false
    },
    backgroundColor: {
      type: String,
      default: "black",
      required: false
    }
  },
  data() {
    return {
      transition: false
    }
  },
  mounted () {
    document.body.addEventListener('keyup', e => {
      if (e.key === 'Escape') this.$emit('close')
    })
    setTimeout(()=>{ this.transition = true }, 1)
  },
  computed: {},
  methods: {}
}
</script>

<style scoped lang="scss">
.modal-enter, .modal-leave-active {
  opacity: 0;
}
.modal-enter .modal-content,
.modal-leave-active .modal-content {
  transform: scale(1.2);
}
.modal__wrapper{
  display: flex;
  justify-content: center;
  align-items: center;
  position: fixed;
  top: 0;
  bottom: 0;
  left: 0;
  transition: opacity .2s ease;
  right: 0;
  z-index: 998;
  backdrop-filter: blur(6px);
  background-color: rgba(63, 62, 62, 0.4);
  color: whitesmoke!important;
}
.modal-content {
  position: relative;
  max-width: 600px;
  padding: 20px 18px;
  background-color: #232323;
  transition: all .2s ease;
  border-radius: 8px;
  z-index: 999;
  overflow: hidden;
}
.modal-content.black {
  background-color: #232323;
}
.modal-content.white {
  background-color: #ece3e3;
}

@media screen and (min-width: 900px) {
  .modal-content {
    min-width: 500px;
  }
}
.modal-header {
  display: flex;
  align-self: center;
  justify-content: space-between;
  padding-bottom: 20px;
}
.modal-header span {
  font-size: 24px;
}
.button-close {
  position: absolute;
  right: 20px;
  top: 15px;
  cursor: pointer;
  width: 12px;
  height: 12px;
  background: url("../assets/images/icons/close.svg");
  transition: all .3s;
}
.button-close:hover {
  transform: scale(1.1);
}
.modal-body {
  text-align: center;
  padding: 10px;
  max-height: 600px;
  overflow: auto;
}
.modal-body img {
  width: 100% !important;
  max-width: initial!important;
  border-radius: 5px;
}
.modal-bottom {
  padding-top: 40px;
}
a.another-modal {
  color: #000;
  border-bottom: 1px solid #000;
}
// Анимация VUE
.v-transition-modal-enter {
  opacity: 0;
}
.v-transition-modal-enter-active {
  opacity: .3;
  transform: scale(.5, .5);
  transition: all .2s ease-in;
}
.v-transition-modal-enter-to {
  transform: scale(1.05, 1.05);
  opacity: 1;
}
</style>
